signature VARIABLE =
  sig
    type 'a var

    (* create a fresh variable with basename "var" *)
    val new : unit -> 'a var
    (* ... with a suggestive basename *)
    val newNamed : string -> 'a var
    (* create a fresh variable with the same basename as a stale one *)
    val freshen : 'a var -> 'a var

    (* convert a variable to a string of the form <basename>_NNN *)
    val toString : 'a var -> string

    val eq : 'a var * 'a var -> bool
    val compare : 'a var * 'a var -> order

  end
