/* Run with at least 500 bytes of memory to make sure
 * the GC gets invoked.
 */
#include <runtime.h>
extern hotcint_t exception_tag_counter;
void* hotc_mainfun(hotc_t* arg);
#define NUM_ITERATIONS 200

void* hotc_mainfun(hotc_t* arg)
{
  int x;
  hotc_check(arg, 100);
  for(x = 0; x < NUM_ITERATIONS; x++)
  {
    hotc_check(arg, 101); /* 100 words and a length byte */
    hotc_alloc(100, FALSE);
    if ((x + 1) % (NUM_ITERATIONS / 10) == 0)
      printf("passed %d iterations\n", x);
  }
  printf("success\n");
  hotc_halt(*arg);
}
