signature CPS_CONVERT =
  sig
    type context = IL3Static.Ctx.context

    exception Convert of string
    exception Error of string

    val convert_kind : IL3.kind -> IL4.kind (* just the "identity" *)
    val convert_con : IL3.con -> IL4.con
    val convert_exp : context -> IL3.exp
                   -> IL3.con * {k: IL4.expvar, k_exn: IL4.expvar} * IL4.exp
  end
