
structure Tokens =
struct

    datatype token =
        STRING of string
      | IDENT of string
      | TYVAR of string
      | INT of int
      | CHAR of char
      | FLOAT of real
      | FN
      | LET
      | LOCAL
      | IN
      | OP
      | OPEN
      | END
      | CASE
      | OF
      | AS
      | ELSE
      | IF
      | THEN
      | HASH
      | VAL
      | WITH
      | WITHTYPE
      | AND
      | FUN
      | FUNCTOR
      | TYPE
      | DATATYPE
      | EXCEPTION
      | HANDLE
      | ANDALSO
      | ORELSE
      | INCLUDE
      | INFIX
      | INFIXR
      | NONFIX
      | SHARING
      | STRUCTURE
      | STRUCT
      | SIGNATURE
      | SIG
      | WHERE
      | COLONGREATER
      | DOT
      | LPAREN
      | RPAREN
      | DARROW
      | ARROW
      | COLON
      | SEMICOLON
      | LBRACE
      | RAISE
      | RBRACE
      | BAR
      | UNDERSCORE
      | EQUALS
      | COMMA
      | LBRACKET
      | RBRACKET

    fun eq (FN, FN) = true
      | eq (LET, LET) = true
      | eq (LOCAL, LOCAL) = true
      | eq (IN, IN) = true
      | eq (END, END) = true
      | eq (CASE, CASE) = true
      | eq (OF, OF) = true
      | eq (AS, AS) = true
      | eq (ELSE, ELSE) = true
      | eq (IF, IF) = true
      | eq (THEN, THEN) = true
      | eq (HASH, HASH) = true
      | eq (VAL, VAL) = true
      | eq (WITH, WITH) = true
      | eq (WITHTYPE, WITHTYPE) = true
      | eq (AND, AND) = true
      | eq (FUN, FUN) = true
      | eq (FUNCTOR, FUNCTOR) = true
      | eq (TYPE, TYPE) = true
      | eq (DATATYPE, DATATYPE) = true
      | eq (EXCEPTION, EXCEPTION) = true
      | eq (HANDLE, HANDLE) = true
      | eq (ANDALSO, ANDALSO) = true
      | eq (ORELSE, ORELSE) = true
      | eq (INCLUDE, INCLUDE) = true
      | eq (INFIX, INFIX) = true
      | eq (INFIXR, INFIXR) = true
      | eq (NONFIX, NONFIX) = true
      | eq (SHARING, SHARING) = true
      | eq (STRUCTURE, STRUCTURE) = true
      | eq (STRUCT, STRUCT) = true
      | eq (SIGNATURE, SIGNATURE) = true
      | eq (SIG, SIG) = true
      | eq (WHERE, WHERE) = true
      | eq (COLONGREATER, COLONGREATER) = true
      | eq (RAISE, RAISE) = true
      | eq (DOT, DOT) = true
      | eq (LPAREN, LPAREN) = true
      | eq (RPAREN, RPAREN) = true
      | eq (DARROW, DARROW) = true
      | eq (ARROW, ARROW) = true
      | eq (COLON, COLON) = true
      | eq (SEMICOLON, SEMICOLON) = true
      | eq (LBRACE, LBRACE) = true
      | eq (RBRACE, RBRACE) = true
      | eq (OP, OP) = true
      | eq (OPEN, OPEN) = true
      | eq (BAR, BAR) = true
      | eq (UNDERSCORE, UNDERSCORE) = true
      | eq (EQUALS, EQUALS) = true
      | eq (COMMA, COMMA) = true
      | eq (LBRACKET, LBRACKET) = true
      | eq (RBRACKET, RBRACKET) = true
      | eq _ = false
end
